//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "OptionsDlgs.h"
#include "Pop3mail.h"
#include "global.h"
#include "fileman.h"
#include "mixmaster.h"
#include "pgpmail.h"
#include "nymmail.h"
#include "pgpfiles.h"
#include "helpdlgs.h"
#include "mainmdi.h"
#include "pgpsdk.h"

#define IniValue1orEmpty(inikey) (ini->Values[inikey]=="1" || ini->Values[inikey].IsEmpty())
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOptionsDlg *OptionsDlg;
//---------------------------------------------------------------------------
bool __fastcall GetPreferences(AnsiString &PageCap)
{
   bool ok=false;
   TColor mfcolor = AppMainForm->Color;
   TOptionsDlg *pf = new TOptionsDlg(AppMainForm);
   CenterDialog(pf,AppMainForm);

   // hide items depending actual capabilities
   pf->TabSheet4->TabVisible = HasPop3();
   //pf->TabSheet5->TabVisible = pf->GroupBox5->Visible = HasMix();
   pf->TabSheet5->TabVisible = HasMix();
   pf->PgpSheet->TabVisible = HasPgp();
   pf->NymSheet->TabVisible = pf->PgpSheet->TabVisible && HasNyms();

   TPageControl *pc = pf->PageControl1;
   int page = 0;
   for (int i=0; i<pc->PageCount; i++)
   {
      AnsiString cap = pc->Pages[i]->Caption.Trim().LowerCase();
      if (pc->Pages[i]->Caption.Trim().LowerCase()==PageCap.LowerCase() && pc->Pages[i]->TabVisible)
      {
         page = i;
         break;
      }
   }
   TTabSheet *active = pc->ActivePage = pc->Pages[page];
   if (active==pf->PgpSheet || active==pf->EdSheet)
      pf->HelpBtn->Enabled = true;

   pf->ShowModal();
   if (pf->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TOptionsDlg::TOptionsDlg(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString txt;
   ini = new TStringList();
   GetAppData(ini,AppIniValues);
   initcomplete = false; cpunkchange = false;
   // general
   txt = ini->Values[QuoteMarks];
   if (txt.IsEmpty()) txt = "> "; txt = "\""+txt+"\"";
   QuoteMarkEdit->Text = txt;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = ini->Values[StatsMinUpdates];
   SortMailboxes->Checked = IniValue1orEmpty(MailboxesSorted);
   ShowBetaTest->Checked = IniValue1orEmpty(OpenBetaTestDialog);
   // editor
   EdWrapWinBtn->Checked = ini->Values[WordWrap].ToIntDef(1);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
   // EdWrapShowBox->Checked = ini->Values[WordWrapShowBox].ToIntDef(0);
   // sending mail
   bool checked = ini->Values[SendWrapChars].ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   txt = ini->Values[SendWrapCharsCount];
   SendWrapCharEdit->Text = txt.IsEmpty()?AnsiString("65"):txt;
   SendWrapWinBtn->Checked = ini->Values[SendWrapWin].ToIntDef(1);
   SendWrapNotBtn->Checked = ini->Values[SendWrapNot].ToIntDef(0);
   DontWrapQuotes->Checked = ini->Values[DontWrapQuoted].ToIntDef(0);
   SendChainLogMax->Text = s(ini->Values[ChainLogMax].ToIntDef(16));
   SendSMTPLogMax->Text  = s(ini->Values[SMTPLogMax].ToIntDef(16));
   SendDateHdrBox->Checked = ini->Values[SendDateHdr].ToIntDef(0);
   ReceivePOP3LogMax->Text = s(ini->Values[POP3LogMax].ToIntDef(16));
   RemailerErrChkLogMax->Text  = s(ini->Values[ErrChkLogMax].ToIntDef(16));
   RemailerTimeOut->Text = s(ini->Values[StatsTimeOut].ToIntDef(30));
   // pgp
   AnsiString pub,sec;
   // keyrings
   pub = ini->Values[PgpPubRing];
   if (pub.IsEmpty() || !FileExists(pub)) pub = PgpPublicRing();
   PgpPublicKeyring->Text = pub;
   sec = ini->Values[PgpSecRing];
   if (sec.IsEmpty() || !FileExists(sec)) sec = PgpSecretRing();
   PgpSecretKeyring->Text = sec;
   // pgp6
   AutoImportBox->Checked = HasPgp() && IniValue1orEmpty(Pgp6AutoImport);
   KeepPassMins->Text = ini->Values[KeepPasswordMin];
   if (KeepPassMins->Text.IsEmpty())KeepPassMins->Text = "0";
   // nyms
   NymShowPopupBox->Checked = HasNyms() && IniValue1orEmpty(NymShowIntro);
   NymAutoDecryptBox->Checked = HasNyms() && IniValue1orEmpty(NymAutoDecrypt);
   GetAppData(NymCmdsEditor->Lines,NymCommandsKey);
   if (NymCmdsEditor->Lines->Text.IsEmpty()) NymCmdsEditor->Lines->CommaText = DefNymCmds;
   NymCmdsEditor->Modified = false;
   // cyberpunk remailers
   EnableCpkBox->Checked = HasPgp() && ini->Values[EnableCyberpunk]=="1";
   EnableCpkBox->Visible = false; //HasPgp();
   // init OpenPubring dialog
   AnsiString curpubring=pubkeyfile=PgpPublicRing();
   if (FileExists(curpubring))
   {
      OpenPubring->InitialDir = ExtractFilePath(curpubring);
      OpenPubring->FileName = ExtractFileName(curpubring);
   }
   OpenPubring->Filter = "Public Keyring Files (*.pkr;*.pubkr;*.pgp)|*.PKR; *.PUBKR; *.PGP|All Files (*.*)|*.*";
   // init OpenSecring dialog
   AnsiString cursecring=seckeyfile=PgpSecretRing();
   if (FileExists(cursecring))
   {
      OpenSecring->InitialDir = ExtractFilePath(cursecring);
      OpenSecring->FileName = ExtractFileName(cursecring);
   }
   OpenSecring->Filter = "Secret Keyring Files (*.skr;*.prvkr;*.pgp)|*.SKR; *.PVRKR; *.PGP|All Files (*.*)|*.*";
   // is pgp6 available ?
   if (HasSdk())
   {
      PublicKeyring6->Caption = PGPqdkPubringpkr().LowerCase();
      SecretKeyring6->Caption = PGPqdkSecringskr().LowerCase();
   }
   else
   {
      AutoImportBox->Enabled = false;
      AutoImportBox->Checked = false;
      PublicKeyring6->Enabled = false;
      SecretKeyring6->Enabled = false;
      ImportBtn->Enabled = false;
      Label7->Enabled = false;
      Label13->Enabled = false;
   }
   // finish init
   PageControl1->ActivePage = TabSheet3;
   HelpBtn->Enabled = false; // remove when 'General' tab help is installed
   initcomplete = true;
}
//---------------------------------------------------------------------------
bool __fastcall FileNamesEqual(AnsiString firstname, AnsiString othername)
{
   AnsiString first=GetShortFileName(firstname).LowerCase();
   AnsiString other=GetShortFileName(othername).LowerCase();
   return first==other;
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDlg::CheckPGPFilenameColision()
{
   AnsiString
      PGPpub = PgpPublicKeyring->Text,
      QDKpub = PublicKeyring6->Caption,
      PGPsec = PgpSecretKeyring->Text,
      QDKsec = PublicKeyring6->Caption;

   if (FileNamesEqual(PGPpub,QDKpub) || FileNamesEqual(PGPsec,QDKsec))
   {
      if (MsgBoxHwnd(Handle,
        s("You have a conflict in filenames. It appears you have PGP 6\n")+
        s("installed and the QuickSilver keyrings specified are the same\n")+
        s("as your PGP 6 keyrings. You must specify separate files.\n\n")+
        s("How about I put the QS keyrings in the QS home directory?\n"),
        s("PGP Filename Collision!"),
         MB_OKCANCEL)==IDCANCEL)
      {
         return false;
      }
      PgpPublicKeyring->Text = AppDir+ExtractFileName(PublicKeyring6->Caption);
      PgpSecretKeyring->Text = AppDir+ExtractFileName(SecretKeyring6->Caption);
      PGPqdkCheckPGP6NeedsUpdate(this,PgpSheet);
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (HasSdk())
      {
         if (!CheckPGPFilenameColision())
         {
            CanClose = false;
            return;
         }
      }
      if (SendSMTPLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum SMTP Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendSMTPLogMax;
         CanClose = false;
         return;
      }
      if (SendChainLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum CHAIN Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendChainLogMax;
         CanClose = false;
         return;
      }
      if (ReceivePOP3LogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum POP3 Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet4;
         ActiveControl = ReceivePOP3LogMax;
         CanClose = false;
         return;
      }
      if (RemailerErrChkLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum ERROR CHECK Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerErrChkLogMax;
         CanClose = false;
         return;
      }
      if (RemailerTimeOut->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Download TIMEOUT seconds must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerTimeOut;
         CanClose = false;
         return;
      }
      Hide();
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      ini->Values[QuoteMarks] = qm;
      ini->Values[StatsMinUpdates] = StatsMinutes->Text;
      ini->Values[WorkSpaceColor] = AnsiString(ColorBox->Color);
      ini->Values[MailboxesSorted] = SortMailboxes->Checked ? "1":"0";
      ini->Values[OpenBetaTestDialog] = ShowBetaTest->Checked ? "1":"0";
      //if (AppMainForm->Color != ColorBox->Color)
      AppMainForm->Color  = ColorBox->Color;
      TStrings *colors = ColorDialog1->CustomColors;
      int p; while ((p=colors->IndexOf("FFFFFFFF"))>=0) colors->Delete(p);
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      ini->Values[WordWrap] = EdWrapWinBtn->Checked?"1":"0";
//      ini->Values[WordWrapShowBox] = EdWrapShowBox->Checked?"1":"0";
      // sending mail
      ini->Values[SendWrapChars] = SendWrapCharBtn->Checked?"1":"0";
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      ini->Values[SendWrapCharsCount] = AnsiString(count<16?16:count);
      ini->Values[SendWrapWin] = SendWrapWinBtn->Checked?"1":"0";
      ini->Values[SendWrapNot] = SendWrapNotBtn->Checked?"1":"0";
      ini->Values[SendDateHdr] = SendDateHdrBox->Checked?"1":"0";
      ini->Values[DontWrapQuoted] = DontWrapQuotes->Checked?"1":"0";
      ini->Values[ChainLogMax] = SendChainLogMax->Text;
      ini->Values[SMTPLogMax] = SendSMTPLogMax->Text;
      ini->Values[POP3LogMax] = ReceivePOP3LogMax->Text;
      ini->Values[ErrChkLogMax] = RemailerErrChkLogMax->Text;
      ini->Values[StatsTimeOut] = RemailerTimeOut->Text;
      // pgp
      ini->Values[PgpPubRing] = PgpPublicKeyring->Text;
      ini->Values[PgpSecRing] = PgpSecretKeyring->Text;
      ini->Values[Pgp6AutoImport] = AutoImportBox->Checked ? "1":"0";
      ini->Values[KeepPasswordMin] = s(KeepPassMins->Text.ToIntDef(0));
      ini->Values[EnableCyberpunk] = EnableCpkBox->Checked ? "1":"0";
      // nyms
      ini->Values[NymShowIntro] = NymShowPopupBox->Checked ? "1":"0";
      ini->Values[NymAutoDecrypt] = NymAutoDecryptBox->Checked ? "1":"0";
      if (NymCmdsEditor->Modified) PutAppData(NymCommandsKey,NymCmdsEditor->Lines);
      // store data
      PutAppData(AppIniValues,ini);
   }
   if (cpunkchange)
   {
      if (CYBERPUNKENABLED) MainForm->SetCyberpunk();
      else MainForm->SetNoCyberpunk();
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::SendWrapBtnClick(TObject *Sender)
{
   bool enabled = SendWrapCharBtn->Checked;
   SendWrapCharEdit->Color = enabled ? clWindow:clBtnFace;
   SendWrapCharEdit->Enabled = enabled;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::SendWrapCharEditExit(TObject *Sender)
{
  if (SendWrapCharEdit->Text.ToIntDef(0)<16)
      SendWrapCharEdit->Text = "16";
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::StatsMinutesExit(TObject *Sender)
{
   if (StatsMinutes->Text.ToIntDef(-1)<0)
      StatsMinutes->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ColorBtnClick(TObject *Sender)
{
   ColorDialog1->Color = AppMainForm->Color;
   if (ColorDialog1->Execute() && AppMainForm->Color!=ColorDialog1->Color)
   {
       ColorBox->Color = ColorDialog1->Color;
       ApplyColorBtn->Enabled = true;
   }
   else
       ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ApplyColorBtnClick(TObject *Sender)
{
   AppMainForm->Color = ColorBox->Color;
   ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
   ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::PageControl1Change(TObject *Sender)
{
   TTabSheet *active = PageControl1->ActivePage;
   if (active==PgpSheet) ActiveControl = PgpPublicKeyring;
   if (active==EdSheet ) ActiveControl = EdWrapGroup;
   HelpBtn->Enabled = active==PgpSheet || active==EdSheet;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::BrowsePubringClick(TObject *Sender)
{
   if (OpenPubring->Execute())
      PgpPublicKeyring->Text = OpenPubring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::BrowseSecringClick(TObject *Sender)
{
   if (OpenSecring->Execute())
      PgpSecretKeyring->Text = OpenSecring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *active = PageControl1->ActivePage;
   if (active==EdSheet)
   {
      sections = "OptionsEditor";
      OpenHelp(sections,"Editor Options","",this);
      return;
   }
   if (active==PgpSheet)
   {
      sections = "OptionsPgp\nOptionsPgpImport";
      OpenHelp(sections,"PGP Keyrings","",this);
      return;
   }
}
//---------------------------------------------------------------------------
AnsiString num(int val)
{
   AnsiString anum = AnsiString(val);
   while (anum.Length()<2) anum = " "+anum;
   return anum;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ResetBtnClick(TObject *Sender)
{
   PgpPublicKeyring->Text = pubkeyfile;
   PgpSecretKeyring->Text = seckeyfile;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ImportBtnClick(TObject *Sender)
{
   if (PgpPublicKeyring->Text.Trim().IsEmpty() || PgpSecretKeyring->Text.Trim().IsEmpty())
   {
      MsgBoxHwnd(Handle,
         "You have not specified the pathnames of your QS keyrings!",
         "PGP Keyring Error",
          MB_OK
      );
      return;
   }
   AnsiString pubring=PublicKeyring6->Caption,secring=SecretKeyring6->Caption;
   if (MsgBoxHwnd(Handle,"Import PGP6 keys now?","Confirm",MB_OKCANCEL)==IDOK)
   {
      TMemoryStream *ms = new TMemoryStream();
      if (!FileExists(PgpPublicKeyring->Text))
      {
         AnsiString filename = PgpPublicKeyring->Text;
         AnsiString dir = ExtractFilePath(filename);
         if (!DirectoryExists(dir)) ForceDirectories(dir);
         if (!DirectoryExists(dir))
         {
            MsgBoxHwnd(Handle,
               "Unable to create directory: "+dir,
               "File Specification",
                MB_OK
            );
            return;
         }
         try
         {
            ms->SaveToFile(filename);
            PutAppIni(PgpPubRing,filename);
         }
         catch (...)
         {
            MsgBoxHwnd(Handle,
               "Unable to create keyring: "+filename,
               "Filename Error",
                MB_OK
            );
            return;
         }
      }
      if (!FileExists(PgpSecretKeyring->Text))
      {
         AnsiString filename = PgpSecretKeyring->Text;
         AnsiString dir = ExtractFilePath(filename);
         if (!DirectoryExists(dir)) ForceDirectories(dir);
         if (!DirectoryExists(dir))
         {
            MsgBoxHwnd(Handle,
               "Unable to create directory: "+dir,
               "File Specification",
                MB_OK
            );
            return;
         }
         try
         {
            ms->SaveToFile(filename);
            PutAppIni(PgpSecRing,filename);
         }
         catch (...)
         {
            MsgBoxHwnd(Handle,
               "Unable to create keyring: "+filename,
               "Filename Error",
                MB_OK
            );
            return;
         }
      }
      PublicKeyring6->Caption = "working...";
      SecretKeyring6->Caption = "";
      AppProcessMessages();
      PGPqdkUpdateQSKeyrings(this,PgpSheet);
      Sleep(200);
      PublicKeyring6->Caption = "Keyrings updated!";
      SecretKeyring6->Caption = "";
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::EnableCpkBoxClick(TObject *Sender)
{
   if (HasPgp() && EnableCpkBox->Checked && initcomplete)
   {

      if (MsgBoxHwnd(Handle,
         s("Cypherpunk features are still under construction.\n\n")+
         s("Enabling them now will make various cypherpunk items\n")+
         s("visible within QuickSilver, but they have no use."),
         s("Cypherpunk Remailers"),
         MB_OKCANCEL)==IDCANCEL)
      {
         EnableCpkBox->Checked = false;
         return;
      }
   }
   cpunkchange = true;
}
//---------------------------------------------------------------------------
