//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "fileman.h"
#include "PgpFiles.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "Global.h"
//---------------------------------------------------------------------------
AnsiString __fastcall PgpDir()
{
   AnsiString path = ExtractFilePath(GetAppIni(PgpPubRing,""));
   if (!path.IsEmpty() && DirectoryExists(path)) return path;

   path=getenv("PGPPATH");
   if (path.IsEmpty()) path = GetCurrentDir();
   if (path.Length() && path[path.Length()]!='\\') path += "\\";
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpPublicRing()
{
   AnsiString name = GetAppIni(PgpPubRing,"");
   if (!name.IsEmpty() && FileExists(name)) return name;

   name=PgpDir()+"pubring.pgp";
   if (!FileExists(name)) name = PgpDir()+"pubring.pubkr";
   if (!FileExists(name)) name = PgpDir()+"pubring.pkr";
   if (!FileExists(name)) name = "";
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpSecretRing()
{
   AnsiString name = GetAppIni(PgpSecRing,"");
   if (!name.IsEmpty() && FileExists(name)) return name;
   name=PgpDir()+"secring.pgp";
   if (!FileExists(name)) name = PgpDir()+"secring.skr";
   if (!FileExists(name)) name = "";
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpRemailRing()
{
   AnsiString remring=MixDir()+CRingTxt;
   if (!FileExists(remring)) remring = "";
   return remring;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpImportRing()
{
   return GetAppIni(PgpImpRing,"");
}
//---------------------------------------------------------------------------
int __fastcall BeginPgpPubKeyBlockCount(TStrings *block)
{
   int c=0; for (int i=0; i<block->Count; i++)
      if (block->Strings[i]==BeginPgpPubKeyBlock) c++;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall IsPGPArmoredHead(AnsiString line)
{
   return line==BeginPgpPubKeyBlock || line=="- "+BeginPgpPubKeyBlock ||
          line==BeginPgpSecKeyBlock || line=="- "+BeginPgpSecKeyBlock;
}
//---------------------------------------------------------------------------
bool __fastcall IsPGPArmoredTail(AnsiString line)
{
   return line==EndPgpPubKeyBlock || line=="- "+EndPgpPubKeyBlock ||
          line==EndPgpSecKeyBlock || line=="- "+EndPgpSecKeyBlock;
}
//---------------------------------------------------------------------------
bool __fastcall GetNextPGPArmored(BUFFER *asckeys, BUFFER *armored)
{
   TStringList *all = new TStringList();
   TStringList *next = new TStringList();
   all->SetText((char*)armored->data);

   bool ok=GetNextPGPArmored(next,all);

   buf_sets(asckeys,next->Text.c_str());
   buf_sets(armored,all->Text.c_str());
   delete next;
   delete all;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GetNextPGPArmored(TStrings *asckeys, TStrings *armored)
{
   while (armored->Count && !IsPGPArmoredHead(armored->Strings[0])) armored->Delete(0);
   while (armored->Count)
   {
      asckeys->Add(armored->Strings[0]); armored->Delete(0);
      if (IsPGPArmoredTail(armored->Strings[0]))
         break;
   }
   if (asckeys->Count>3 && asckeys->Strings[0]=="- "+BeginPgpPubKeyBlock)
   {
      asckeys->Strings[asckeys->Count-1] = EndPgpPubKeyBlock;
      asckeys->Strings[0] = BeginPgpPubKeyBlock;
   }
   return asckeys->Count>3;
}
//---------------------------------------------------------------------------
/*bool __fastcall GetNextPGPArmored(BUFFER *asckeys, BUFFER *armored)
{
   TStringList *all = new TStringList();
   TStringList *next = new TStringList();
   all->SetText((char*)armored->data);
   while (all->Count && !IsPGPArmoredHead(all->Strings[0])) all->Delete(0);
   while (all->Count)
   {
      next->Add(all->Strings[0]); all->Delete(0);
      if (IsPGPArmoredTail(all->Strings[0]))
         break;
   }
   bool ok=next->Count>0;
   buf_sets(asckeys,next->Text.c_str());
   buf_sets(armored,all->Text.c_str());
   delete next;
   delete all;
   return ok;
}*/
//---------------------------------------------------------------------------
